﻿
-- Remove SP
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_cls_OZTestObjectWCardInsert]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_cls_OZTestObjectWCardInsert]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_cls_OZTestObjectWCardUpdate]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_cls_OZTestObjectWCardUpdate]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_cls_OZTestObjectWCardDelete]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_cls_OZTestObjectWCardDelete]
GO 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_cls_OZTestObjectWCardSelect]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_cls_OZTestObjectWCardSelect]
GO

-- Create SP
CREATE PROCEDURE [dbo].[mc_cls_OZTestObjectWCardInsert]
(
@OZTestObjectWCardId int = NULL OUTPUT
,
@Created datetime,
@CreatorId int,
@Modified datetime,
@ModifierId int,
@Card nvarchar(50) = NULL
,
@Name nvarchar(100),
@NullableTime datetime = NULL
,
@File int = NULL
)
AS
    SET NOCOUNT ON

INSERT INTO [cls_OZTestObjectWCard]
(
[Created],
[CreatorId],
[Modified],
[ModifierId],
[Card],
[Name],
[NullableTime],
[File])
VALUES(
@Created,
@CreatorId,
@Modified,
@ModifierId,
@Card,
@Name,
@NullableTime,
@File)
SELECT @OZTestObjectWCardId = SCOPE_IDENTITY();
RETURN @@Error
GO
CREATE PROCEDURE [dbo].[mc_cls_OZTestObjectWCardUpdate]
(
@OZTestObjectWCardId int,
@Created datetime,
@CreatorId int,
@Modified datetime,
@ModifierId int,
@Card nvarchar(50) = NULL
,
@Name nvarchar(100),
@NullableTime datetime = NULL
,
@File int = NULL
)
AS
    SET NOCOUNT ON

UPDATE [cls_OZTestObjectWCard]
SET
[Created] = @Created,
[CreatorId] = @CreatorId,
[Modified] = @Modified,
[ModifierId] = @ModifierId,
[Card] = @Card,
[Name] = @Name,
[NullableTime] = @NullableTime,
[File] = @File
WHERE
[OZTestObjectWCardId] = @OZTestObjectWCardId
RETURN @@Error
GO
CREATE PROCEDURE [dbo].[mc_cls_OZTestObjectWCardDelete]
(
@OZTestObjectWCardId int
)
AS
    SET NOCOUNT ON

DELETE FROM [cls_OZTestObjectWCard]
WHERE
[OZTestObjectWCardId] = @OZTestObjectWCardId
RETURN @@Error
GO
CREATE PROCEDURE [dbo].[mc_cls_OZTestObjectWCardSelect]
(
@OZTestObjectWCardId int
)
AS
    SET NOCOUNT ON

SELECT [OZTestObjectWCardId],
[Created],
[CreatorId],
[Modified],
[ModifierId],
[Card],
[Name],
[NullableTime],
[File] FROM cls_OZTestObjectWCard
WHERE
[OZTestObjectWCardId] = @OZTestObjectWCardId
GO

-- End