﻿
using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using Mediachase.Ibn.Data;
using Mediachase.Ibn.Data.Sql;

namespace Mediachase.Ibn.Core
{

	public partial class mcweb_FilterSetRow
	{
		private DataRowState _state = DataRowState.Unchanged;


		Nullable<int> _FilterSetId;
		int _UserId;
		string _MetaClassName;
		string _Id;
		string _Name;
		string _XSFilters;


		public mcweb_FilterSetRow()
		{
			_state = DataRowState.Added;


		}

		public mcweb_FilterSetRow(int FilterSetId)
		{
			using (IDataReader reader = DataHelper.Select("mcweb_FilterSet", 
							"FilterSetId", 
							SqlDbType.Int,
							FilterSetId))
			{
				if (reader.Read()) 
				{
					Load(reader);
				}
				else throw new Exception(String.Format("Record with {0}.{1}={2} not found", "mcweb_FilterSet", "FilterSetId", FilterSetId));
			}
		}
		
		public mcweb_FilterSetRow(IDataReader reader)
		{
			Load(reader);
		}
		
		protected virtual void Load(IDataReader reader)
		{
			_state = DataRowState.Unchanged;
			
		
			_FilterSetId = (int)SqlHelper.DBNull2Null(reader["FilterSetId"]);
			
			_UserId = (int)SqlHelper.DBNull2Null(reader["UserId"]);
			
			_MetaClassName = (string)SqlHelper.DBNull2Null(reader["MetaClassName"]);
			
			_Id = (string)SqlHelper.DBNull2Null(reader["Id"]);
			
			_Name = (string)SqlHelper.DBNull2Null(reader["Name"]);
			
			_XSFilters = (string)SqlHelper.DBNull2Null(reader["XSFilters"]);
			
		}

		#region Public Properties

		public virtual Nullable<int> PrimaryKeyId
		{
			get { return _FilterSetId; }
			set { _FilterSetId = value; }
		}
		
        
		public virtual int FilterSetId
	    
		{
			get
			{
				
				return (int)_FilterSetId;
				
			}
			
		}
		
		public virtual int UserId
	    
		{
			get
			{
				
				return _UserId;
				
			}
			
			set
			{
				_UserId = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string MetaClassName
	    
		{
			get
			{
				
				return _MetaClassName;
				
			}
			
			set
			{
				_MetaClassName = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string Id
	    
		{
			get
			{
				
				return _Id;
				
			}
			
			set
			{
				_Id = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string Name
	    
		{
			get
			{
				
				return _Name;
				
			}
			
			set
			{
				_Name = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string XSFilters
	    
		{
			get
			{
				
				return _XSFilters;
				
			}
			
			set
			{
				_XSFilters = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		#endregion
	
		public static mcweb_FilterSetRow[] List()
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_FilterSet"))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_FilterSetRow(reader));
				}
			}
			return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
		}
	
		public static mcweb_FilterSetRow[] List(params SortingElement[] sorting)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_FilterSet", sorting))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_FilterSetRow(reader));
				}
			}
			return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
		}

		public static mcweb_FilterSetRow[] List(params FilterElement[] filters)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_FilterSet", filters))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_FilterSetRow(reader));
				}
			}
			return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
		}

		public static mcweb_FilterSetRow[] List(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_FilterSet", filters, sorting))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new mcweb_FilterSetRow(reader));
			  } 
	       }
	       return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
	    }

	    public static mcweb_FilterSetRow[] List(FilterElementCollection filters, SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_FilterSet", filters, sorting))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new mcweb_FilterSetRow(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
	    }
	
	    public static mcweb_FilterSetRow[] List(SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_FilterSet", sorting.ToArray()))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new mcweb_FilterSetRow(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (mcweb_FilterSetRow[])list.ToArray(typeof(mcweb_FilterSetRow));
	    }
	
	    public static int GetTotalCount(params FilterElement[] filters)
	    {
	        return DataHelper.GetTotalCount("mcweb_FilterSet", filters);
	    }
	
	    public static IDataReader GetReader()
	    {
	       return DataHelper.List("mcweb_FilterSet");
	    }
	
	    public static IDataReader GetReader(params FilterElement[] filters)
	    {
	       return DataHelper.List("mcweb_FilterSet", filters);
	    }
	
	    public static IDataReader GetReader(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       return DataHelper.List("mcweb_FilterSet", filters, sorting);
	    }
	
	    public static DataTable GetTable()
	    {
	       return DataHelper.GetDataTable("mcweb_FilterSet");
	    }
	
	    public static DataTable GetTable(params FilterElement[] filters)
	    {
	       return DataHelper.GetDataTable("mcweb_FilterSet", filters);
	    }

		public virtual void Update()
		{
			if (_state == DataRowState.Modified) 
			{
				DataHelper.Update("mcweb_FilterSet"

					, SqlHelper.SqlParameter("@FilterSetId", SqlDbType.Int, _FilterSetId)

					, SqlHelper.SqlParameter("@UserId", SqlDbType.Int, _UserId)

					, SqlHelper.SqlParameter("@MetaClassName", SqlDbType.NVarChar, 50, _MetaClassName)

					, SqlHelper.SqlParameter("@Id", SqlDbType.NVarChar, 50, _Id)

					, SqlHelper.SqlParameter("@Name", SqlDbType.NVarChar, 250, _Name)

					, SqlHelper.SqlParameter("@XSFilters", SqlDbType.NText, _XSFilters)

				);
			}
			else if (_state == DataRowState.Added) 
			{

				_FilterSetId = DataHelper.Insert("mcweb_FilterSet", "FilterSetId" 

					, SqlHelper.SqlParameter("@FilterSetId", SqlDbType.Int, _FilterSetId)

					, SqlHelper.SqlParameter("@UserId", SqlDbType.Int, _UserId)

					, SqlHelper.SqlParameter("@MetaClassName", SqlDbType.NVarChar, 50, _MetaClassName)

					, SqlHelper.SqlParameter("@Id", SqlDbType.NVarChar, 50, _Id)

					, SqlHelper.SqlParameter("@Name", SqlDbType.NVarChar, 250, _Name)

					, SqlHelper.SqlParameter("@XSFilters", SqlDbType.NText, _XSFilters)

				);

			}
		}

		public virtual void Delete()
		{
			_state = DataRowState.Deleted;
		
			Delete(this.FilterSetId);
		}

		public static void Delete(int FilterSetId)
		{
			DataHelper.Delete("mcweb_FilterSet",
				"FilterSetId",
				SqlDbType.Int,
				FilterSetId);
		}
	}
}
