﻿
-- Remove SP
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetInsert]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_FilterSetInsert]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetUpdate]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_FilterSetUpdate]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetDelete]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_FilterSetDelete]
GO 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetSelect]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_FilterSetSelect]
GO

-- Create SP
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetInsert]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_FilterSetInsert]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_FilterSetInsert]
@UserId AS Int,
@MetaClassName AS NVarChar(4000),
@Id AS NVarChar(4000),
@Name AS NVarChar(4000),
@XSFilters AS NText,
@FilterSetId AS Int = NULL OUTPUT
AS
BEGIN
SET NOCOUNT ON;

INSERT INTO [mcweb_FilterSet]
(
[UserId],
[MetaClassName],
[Id],
[Name],
[XSFilters])
VALUES(
@UserId,
@MetaClassName,
@Id,
@Name,
@XSFilters)
SELECT @FilterSetId = SCOPE_IDENTITY();
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetUpdate]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_FilterSetUpdate]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_FilterSetUpdate]
@UserId AS Int,
@MetaClassName AS NVarChar(4000),
@Id AS NVarChar(4000),
@Name AS NVarChar(4000),
@XSFilters AS NText,
@FilterSetId AS Int
AS
BEGIN
SET NOCOUNT ON;

UPDATE [mcweb_FilterSet] SET
[UserId] = @UserId,
[MetaClassName] = @MetaClassName,
[Id] = @Id,
[Name] = @Name,
[XSFilters] = @XSFilters WHERE
[FilterSetId] = @FilterSetId
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetDelete]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_FilterSetDelete]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_FilterSetDelete]
@FilterSetId AS Int
AS
BEGIN
SET NOCOUNT ON;

DELETE FROM [mcweb_FilterSet]
WHERE
[FilterSetId] = @FilterSetId
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_FilterSetSelect]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_FilterSetSelect]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_FilterSetSelect]
@FilterSetId AS Int
AS
BEGIN
SET NOCOUNT ON;

SELECT [t01].[FilterSetId] AS [FilterSetId], [t01].[UserId] AS [UserId], [t01].[MetaClassName] AS [MetaClassName], [t01].[Id] AS [Id], [t01].[Name] AS [Name], [t01].[XSFilters] AS [XSFilters]
FROM [mcweb_FilterSet] AS [t01]
WHERE ([t01].[FilterSetId]=@FilterSetId)
END

-- End