﻿
using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using Mediachase.Ibn.Data;
using Mediachase.Ibn.Data.Sql;

namespace Mediachase.Ibn.Core
{

	public partial class mcweb_ListViewProfileRow
	{
		private DataRowState _state = DataRowState.Unchanged;


		Nullable<int> _ListViewProfileId;
		int _UserId;
		string _MetaClassName;
		string _Id;
		bool _IsPublic;
		string _XSListViewProfile;


		public mcweb_ListViewProfileRow()
		{
			_state = DataRowState.Added;


		}

		public mcweb_ListViewProfileRow(int ListViewProfileId)
		{
			using (IDataReader reader = DataHelper.Select("mcweb_ListViewProfile", 
							"ListViewProfileId", 
							SqlDbType.Int,
							ListViewProfileId))
			{
				if (reader.Read()) 
				{
					Load(reader);
				}
				else throw new Exception(String.Format("Record with {0}.{1}={2} not found", "mcweb_ListViewProfile", "ListViewProfileId", ListViewProfileId));
			}
		}
		
		public mcweb_ListViewProfileRow(IDataReader reader)
		{
			Load(reader);
		}
		
		protected virtual void Load(IDataReader reader)
		{
			_state = DataRowState.Unchanged;
			
		
			_ListViewProfileId = (int)SqlHelper.DBNull2Null(reader["ListViewProfileId"]);
			
			_UserId = (int)SqlHelper.DBNull2Null(reader["UserId"]);
			
			_MetaClassName = (string)SqlHelper.DBNull2Null(reader["MetaClassName"]);
			
			_Id = (string)SqlHelper.DBNull2Null(reader["Id"]);
			
			_IsPublic = (bool)SqlHelper.DBNull2Null(reader["IsPublic"]);
			
			_XSListViewProfile = (string)SqlHelper.DBNull2Null(reader["XSListViewProfile"]);
			
		}

		#region Public Properties

		public virtual Nullable<int> PrimaryKeyId
		{
			get { return _ListViewProfileId; }
			set { _ListViewProfileId = value; }
		}
		
        
		public virtual int ListViewProfileId
	    
		{
			get
			{
				
				return (int)_ListViewProfileId;
				
			}
			
		}
		
		public virtual int UserId
	    
		{
			get
			{
				
				return _UserId;
				
			}
			
			set
			{
				_UserId = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string MetaClassName
	    
		{
			get
			{
				
				return _MetaClassName;
				
			}
			
			set
			{
				_MetaClassName = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string Id
	    
		{
			get
			{
				
				return _Id;
				
			}
			
			set
			{
				_Id = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual bool IsPublic
	    
		{
			get
			{
				
				return _IsPublic;
				
			}
			
			set
			{
				_IsPublic = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		public virtual string XSListViewProfile
	    
		{
			get
			{
				
				return _XSListViewProfile;
				
			}
			
			set
			{
				_XSListViewProfile = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			
		}
		
		#endregion
	
		public static mcweb_ListViewProfileRow[] List()
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile"))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_ListViewProfileRow(reader));
				}
			}
			return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
		}
	
		public static mcweb_ListViewProfileRow[] List(params SortingElement[] sorting)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile", sorting))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_ListViewProfileRow(reader));
				}
			}
			return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
		}

		public static mcweb_ListViewProfileRow[] List(params FilterElement[] filters)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile", filters))
			{
				while (reader.Read())
				{
					list.Add(new mcweb_ListViewProfileRow(reader));
				}
			}
			return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
		}

		public static mcweb_ListViewProfileRow[] List(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile", filters, sorting))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new mcweb_ListViewProfileRow(reader));
			  } 
	       }
	       return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
	    }

	    public static mcweb_ListViewProfileRow[] List(FilterElementCollection filters, SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile", filters, sorting))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new mcweb_ListViewProfileRow(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
	    }
	
	    public static mcweb_ListViewProfileRow[] List(SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("mcweb_ListViewProfile", sorting.ToArray()))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new mcweb_ListViewProfileRow(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (mcweb_ListViewProfileRow[])list.ToArray(typeof(mcweb_ListViewProfileRow));
	    }
	
	    public static int GetTotalCount(params FilterElement[] filters)
	    {
	        return DataHelper.GetTotalCount("mcweb_ListViewProfile", filters);
	    }
	
	    public static IDataReader GetReader()
	    {
	       return DataHelper.List("mcweb_ListViewProfile");
	    }
	
	    public static IDataReader GetReader(params FilterElement[] filters)
	    {
	       return DataHelper.List("mcweb_ListViewProfile", filters);
	    }
	
	    public static IDataReader GetReader(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       return DataHelper.List("mcweb_ListViewProfile", filters, sorting);
	    }
	
	    public static DataTable GetTable()
	    {
	       return DataHelper.GetDataTable("mcweb_ListViewProfile");
	    }
	
	    public static DataTable GetTable(params FilterElement[] filters)
	    {
	       return DataHelper.GetDataTable("mcweb_ListViewProfile", filters);
	    }

		public virtual void Update()
		{
			if (_state == DataRowState.Modified) 
			{
				DataHelper.Update("mcweb_ListViewProfile"

					, SqlHelper.SqlParameter("@ListViewProfileId", SqlDbType.Int, _ListViewProfileId)

					, SqlHelper.SqlParameter("@UserId", SqlDbType.Int, _UserId)

					, SqlHelper.SqlParameter("@MetaClassName", SqlDbType.NVarChar, 50, _MetaClassName)

					, SqlHelper.SqlParameter("@Id", SqlDbType.NVarChar, 50, _Id)

					, SqlHelper.SqlParameter("@IsPublic", SqlDbType.Bit, _IsPublic)

					, SqlHelper.SqlParameter("@XSListViewProfile", SqlDbType.NText, _XSListViewProfile)

				);
			}
			else if (_state == DataRowState.Added) 
			{

				_ListViewProfileId = DataHelper.Insert("mcweb_ListViewProfile", "ListViewProfileId" 

					, SqlHelper.SqlParameter("@ListViewProfileId", SqlDbType.Int, _ListViewProfileId)

					, SqlHelper.SqlParameter("@UserId", SqlDbType.Int, _UserId)

					, SqlHelper.SqlParameter("@MetaClassName", SqlDbType.NVarChar, 50, _MetaClassName)

					, SqlHelper.SqlParameter("@Id", SqlDbType.NVarChar, 50, _Id)

					, SqlHelper.SqlParameter("@IsPublic", SqlDbType.Bit, _IsPublic)

					, SqlHelper.SqlParameter("@XSListViewProfile", SqlDbType.NText, _XSListViewProfile)

				);

			}
		}

		public virtual void Delete()
		{
			_state = DataRowState.Deleted;
		
			Delete(this.ListViewProfileId);
		}

		public static void Delete(int ListViewProfileId)
		{
			DataHelper.Delete("mcweb_ListViewProfile",
				"ListViewProfileId",
				SqlDbType.Int,
				ListViewProfileId);
		}
	}
}
