﻿
-- Remove SP
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileInsert]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileInsert]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileUpdate]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileUpdate]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileDelete]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileDelete]
GO 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileSelect]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1) DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileSelect]
GO

-- Create SP
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileInsert]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileInsert]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_ListViewProfileInsert]
@UserId AS Int,
@MetaClassName AS NVarChar(4000),
@Id AS NVarChar(4000),
@IsPublic AS Bit,
@XSListViewProfile AS NText,
@ListViewProfileId AS Int = NULL OUTPUT
AS
BEGIN
SET NOCOUNT ON;

INSERT INTO [mcweb_ListViewProfile]
(
[UserId],
[MetaClassName],
[Id],
[IsPublic],
[XSListViewProfile])
VALUES(
@UserId,
@MetaClassName,
@Id,
@IsPublic,
@XSListViewProfile)
SELECT @ListViewProfileId = SCOPE_IDENTITY();
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileUpdate]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileUpdate]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_ListViewProfileUpdate]
@UserId AS Int,
@MetaClassName AS NVarChar(4000),
@Id AS NVarChar(4000),
@IsPublic AS Bit,
@XSListViewProfile AS NText,
@ListViewProfileId AS Int
AS
BEGIN
SET NOCOUNT ON;

UPDATE [mcweb_ListViewProfile] SET
[UserId] = @UserId,
[MetaClassName] = @MetaClassName,
[Id] = @Id,
[IsPublic] = @IsPublic,
[XSListViewProfile] = @XSListViewProfile WHERE
[ListViewProfileId] = @ListViewProfileId
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileDelete]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileDelete]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_ListViewProfileDelete]
@ListViewProfileId AS Int
AS
BEGIN
SET NOCOUNT ON;

DELETE FROM [mcweb_ListViewProfile]
WHERE
[ListViewProfileId] = @ListViewProfileId
END

GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id (N'[dbo].[mc_mcweb_ListViewProfileSelect]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[mc_mcweb_ListViewProfileSelect]
GO
CREATE PROCEDURE [dbo].[mc_mcweb_ListViewProfileSelect]
@ListViewProfileId AS Int
AS
BEGIN
SET NOCOUNT ON;

SELECT [t01].[ListViewProfileId] AS [ListViewProfileId], [t01].[UserId] AS [UserId], [t01].[MetaClassName] AS [MetaClassName], [t01].[Id] AS [Id], [t01].[IsPublic] AS [IsPublic], [t01].[XSListViewProfile] AS [XSListViewProfile]
FROM [mcweb_ListViewProfile] AS [t01]
WHERE ([t01].[ListViewProfileId]=@ListViewProfileId)
END

-- End