<%@ Page language="c#" Debug="true"%>
<%@ Import namespace="Mediachase.BusinessFoundation.Data.Sql.Management"%>
<%@ Import namespace="Mediachase.CodeGen"%>
<%@ Import namespace="Mediachase.BusinessFoundation.ObjectModel"%>
<% Mediachase.BusinessFoundation.Data.Sql.Management.Table table = (Mediachase.BusinessFoundation.Data.Sql.Management.Table)ObjectModelFactory.Create(); %>
using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using System.Globalization;
using Mediachase.BusinessFoundation.Data;
using Mediachase.BusinessFoundation.Data.Sql;

namespace <%= ObjectModelFactory.Params["Namespace"] %>
{
<%
if(!ObjectModelFactory.Params.ContainsKey("ClassName"))
{
	ObjectModelFactory.Params.Add("ClassName", table.Name + "Row" );
}
%>	
	<% if (ObjectModelFactory.Params.ContainsKey("AccessLevel")) {%>	<%= ObjectModelFactory.Params["AccessLevel"]%><%} else { %>public<%}%> partial class <%= ObjectModelFactory.Params["ClassName"] %>
	{
		private DataRowState _state = DataRowState.Unchanged;
		
		#region Column's name const
		<%
foreach (Column column in table.Columns)
{
	if (!TableObject.IsBinary(column.SqlDbType))
	{
%>
			public const string Column<%=column.Name%> = "<%=column.Name%>";
<%		
	}
}
%>
		#endregion
		
<%
foreach (Column column in table.Columns)
{
	if ((column.IsNullable || table.PrimaryKey.Name==column.Name) && TableObject.IsPrimitive(column.SqlDbType))
	{
%>
		Nullable<<%=TableObject.GetCSType(column.SqlDbType)%>> _<%=column.Name%>;
<%
	}
	else if (!TableObject.IsBinary(column.SqlDbType))
	{
%>
		<%="		"+TableObject.GetCSType(column.SqlDbType)%> _<%=column.Name%>;
<%
	}
}
%>

		public <%= ObjectModelFactory.Params["ClassName"] %>()
		{
			_state = DataRowState.Added;

<%
foreach (Column column in table.Columns)
{
	if (!TableObject.IsBinary(column.SqlDbType))
	{
		string defValue = column.GetDefaultValue();
		if (defValue != null)
		{
%>
			_<%=column.Name%> = <%= defValue%>;
<%
		}
		else if (column.IsNullable)
		{
%>
			_<%=column.Name%> = null;
<%
		}
	}
}
%>
		}

		public <%= ObjectModelFactory.Params["ClassName"] %>(<%=TableObject.GetCSType(table.Columns[table.PrimaryKey.Name].SqlDbType)%> primaryKeyId)
		{
			using (IDataReader reader = DataHelper.Select("<%= table.Name %>", 
							"<%=table.PrimaryKey.Name%>", 
							SqlDbType.<%=TableObject.GetSqlType(table.Columns[table.PrimaryKey.Name].SqlDbType)%>,
							primaryKeyId))
			{
				if (reader.Read()) 
				{
					Load(reader);
				}
				else throw new ArgumentException(String.Format(CultureInfo.InvariantCulture, "Record with {0}.{1}={2} not found", "<%= table.Name %>", "<%=table.PrimaryKey.Name%>", primaryKeyId), "primaryKeyId");
			}
		}
		
		public <%= ObjectModelFactory.Params["ClassName"] %>(IDataReader reader)
		{
			Load(reader);
		}
		
		protected void Load(IDataReader reader)
		{
			_state = DataRowState.Unchanged;
			
		<%foreach (Column column in table.Columns) {%>
		    <%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		    _<%=column.Name %> = (Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> >)SqlHelper.DBNull2Null(reader["<%=column.Name %>"]);
		    <%} %>
		    <%else if (!TableObject.IsBinary(column.SqlDbType)){%>
			_<%=column.Name %> = (<%=TableObject.GetCSType(column.SqlDbType)%>)SqlHelper.DBNull2Null(reader["<%=column.Name %>"]);
			<%} %>
		<%}%>
		
			OnLoad(reader);
		}
		
		protected virtual void OnLoad(IDataReader reader)
		{
		}

		#region Public Properties

		public virtual Nullable<<%=TableObject.GetCSType(table.Columns[table.PrimaryKey.Name].SqlDbType)%>> PrimaryKeyId
		{
			get { return _<%=table.PrimaryKey.Name%>; }
			set { _<%=table.PrimaryKey.Name%> = value; }
		}
		
        <%foreach (Column column in table.Columns) {%>
        <%if(!TableObject.IsBinary(column.SqlDbType)) {%>
      	<%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		public virtual Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> > <%= column.Name %>
	    <%}%>
	    <%else {%>
		public virtual <%=TableObject.GetCSType(column.SqlDbType)%> <%= column.Name %>
	    <%}%>
		{
			get
			{
				<% if (column.Name==table.PrimaryKey.Name) {%>
				return (<%=TableObject.GetCSType(table.Columns[table.PrimaryKey.Name].SqlDbType)%>)_<%= column.Name %>;
				<%} else {%>
				return _<%= column.Name %>;
				<%}%>
			}
			<% if (!column.Identity) {%>
			set
			{
				_<%= column.Name %> = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			<%}%>
		}
		<%}%>
		<%}%>
		#endregion
	
		public static <%= ObjectModelFactory.Params["ClassName"] %>[] List()
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("<%= table.Name %>"))
			{
				while (reader.Read())
				{
					list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
				}
			}
			return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
		}
	
		public static <%= ObjectModelFactory.Params["ClassName"] %>[] List(params SortingElement[] sorting)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("<%= table.Name %>", sorting))
			{
				while (reader.Read())
				{
					list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
				}
			}
			return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
		}

		public static <%= ObjectModelFactory.Params["ClassName"] %>[] List(params FilterElement[] filters)
		{
			ArrayList list = new ArrayList();

			using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters))
			{
				while (reader.Read())
				{
					list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
				}
			}
			return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
		}

		public static <%= ObjectModelFactory.Params["ClassName"] %>[] List(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters, sorting))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
			  } 
	       }
	       return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
	    }

	    public static <%= ObjectModelFactory.Params["ClassName"] %>[] List(FilterElementCollection filters, SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters, sorting))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
	    }
	
	    public static <%= ObjectModelFactory.Params["ClassName"] %>[] List(SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", sorting.ToArray()))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new <%= ObjectModelFactory.Params["ClassName"] %>(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (<%= ObjectModelFactory.Params["ClassName"] %>[])list.ToArray(typeof(<%= ObjectModelFactory.Params["ClassName"] %>));
	    }
	
	    public static int GetTotalCount(params FilterElement[] filters)
	    {
	        return DataHelper.GetTotalCount("<%= table.Name %>", filters);
	    }
	
	    public static IDataReader GetReader()
	    {
	       return DataHelper.List("<%= table.Name %>");
	    }
	
	    public static IDataReader GetReader(params FilterElement[] filters)
	    {
	       return DataHelper.List("<%= table.Name %>", filters);
	    }
	
	    public static IDataReader GetReader(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       return DataHelper.List("<%= table.Name %>", filters, sorting);
	    }
	
	    public static DataTable GetTable()
	    {
	       return DataHelper.GetDataTable("<%= table.Name %>");
	    }
	
	    public static DataTable GetTable(params FilterElement[] filters)
	    {
	       return DataHelper.GetDataTable("<%= table.Name %>", filters);
	    }

		public virtual void Update()
		{
			if (_state == DataRowState.Modified) 
			{
				DataHelper.Update("<%= table.Name %>"
<%
foreach (Column column in table.Columns)
{
	if (TableObject.IsString(column.SqlDbType))
	{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
<%
	}
	else if(!TableObject.IsBinary(column.SqlDbType))
	{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
<%
	}
}
%>
				);
			}
			else if (_state == DataRowState.Added) 
			{
<%
if (table.Columns[table.PrimaryKey.Name].Identity)
{
%>
				_<%=table.PrimaryKey.Name%> = DataHelper.Insert("<%= table.Name %>", "<%=table.PrimaryKey.Name%>" 
<%
	foreach (Column column in table.Columns)
	{
		if (TableObject.IsString(column.SqlDbType))
		{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
<%
		}
		else if(!TableObject.IsBinary(column.SqlDbType))
		{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
<%
		}
	}
%>
				);
<%
}
else
{
%>
				DataHelper.Insert("<%= table.Name %>"
<%
	foreach (Column column in table.Columns)
	{
		if (TableObject.IsString(column.SqlDbType))
		{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
<%
		}
		else if (!TableObject.IsBinary(column.SqlDbType))
		{
%>
					, SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
<%
		}
	}
%>
				);
<%
}
%>
			}
			
			_state = DataRowState.Unchanged;
		}

		public virtual void Delete()
		{
			_state = DataRowState.Deleted;
		
			Delete(this.<%=table.PrimaryKey.Name%>);
		}

		public static void Delete(<%=TableObject.GetCSType(table.Columns[table.PrimaryKey.Name].SqlDbType)%> primaryKeyId)
		{
			DataHelper.Delete("<%= table.Name %>",
				"<%=table.PrimaryKey.Name%>",
				SqlDbType.<%=TableObject.GetSqlType(table.Columns[table.PrimaryKey.Name].SqlDbType)%>,
				primaryKeyId);
		}
	}
}
