<%@ Page language="c#" Debug="true"%>
<%@ Import namespace="Mediachase.CodeGen"%>
<%@ Import namespace="Mediachase.Ibn.Data.Meta.Management"%>
<%@ Import namespace="Mediachase.Ibn.ObjectModel"%>

<% MetaClass metaClass = (MetaClass)ObjectModelFactory.Create(); %>
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// An auto generated class. Don't modify it manually.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Data;

using Mediachase.Ibn.Data;
using Mediachase.Ibn.Data.Business;

<% if (ObjectModelFactory.Params.ContainsKey("Using") )%>
<%{%>
<%foreach (string strUsing in ObjectModelFactory.Params["Using"].Split(new char[] { ';' }, StringSplitOptions.RemoveEmptyEntries))%>
<%{%><%=string.Format("using {0};\r\n", strUsing)%><%}%>
<%}%>

namespace <%= ObjectModelFactory.Params["Namespace"] %>
{
    public partial class <%= metaClass.Name %>Entity: EntityObject
    {
        private EntityObjectProperty[] _exProperties;
        
        #region Util
        public const string ClassName = "<%= metaClass.Name %>";
        public const string PrimaryKeyName = "PrimaryKeyId";
        #endregion
        
        #region Field's name const
        <%foreach(MetaField field in metaClass.Fields) %>
        <%{if (!field.DataSource.InPrimaryKey){%>public const string Field<%=field.Name%> = "<%=field.Name%>";
        <%}%>
        <%}%>
		#endregion
        
        #region .Ctor
        public <%= metaClass.Name %>Entity()
             : base("<%= metaClass.Name %>")
        {
			InitializeProperties();
        }

        public <%= metaClass.Name %>Entity(PrimaryKeyId primaryKeyId)
             : base("<%= metaClass.Name %>", primaryKeyId)
        {
			InitializeProperties();
        }
        
        public <%= metaClass.Name %>Entity(string metaClassName)
            : base(metaClassName)
        {
			InitializeProperties();
        }
        
        public <%= metaClass.Name %>Entity(string metaClassName, PrimaryKeyId primaryKeyId)
            : base(metaClassName, primaryKeyId)
        {
			InitializeProperties();
        }
        #endregion
        
        #region Initialize Properties
        protected void InitializeProperties()
        {
			<%foreach(MetaField field in metaClass.Fields) %>
            <%{if (!field.DataSource.InPrimaryKey){%>base.Properties.Add("<%=field.Name%>", null);
            <%}%>
            <%}%>
        }
        #endregion

        #region Extended Properties
        public EntityObjectProperty[] ExtendedProperties
        {
            get
            {
                if(_exProperties==null)
                {
                    List<EntityObjectProperty> retVal = new List<EntityObjectProperty>();
                    
                    foreach(EntityObjectProperty property in base.Properties)
                    {
                        switch(property.Name)
                        {
                            <%foreach(MetaField field in metaClass.Fields) %>
                            <%{%>case "<%=field.Name%>": 
                            <%}%>
                                 break;
                            default:
                                 retVal.Add(property);    
                                 break;
                        }
                    }
                    _exProperties = retVal.ToArray();
                }
                
                return _exProperties;
            }
            set
            {
                _exProperties = value;
            }
        }
        #endregion
        
        #region Named Properties
        <%foreach(MetaField field in metaClass.Fields) %>
        <%{
              if (!field.DataSource.InPrimaryKey)
              {%>
        public <%=BusinessObject.GetNetTypeByMetaField(field)%> <%=field.Name %>
        {
            get
            {
                return (<%=BusinessObject.GetNetTypeByMetaField(field)%>)base.Properties["<%=field.Name %>"].Value;
            }
            <%if(!field.ReadOnly) %>
            <%{%>
            set
            {
                base.Properties["<%=field.Name %>"].Value = value;
            }
            <%}%>
        }
        <%}%>
        <%}%>
        #endregion
        
        
    }
}
