<%@ Page language="c#" Debug="true"%>
<%@ Import namespace="Mediachase.Ibn.Data.Sql.Management"%>
<%@ Import namespace="Mediachase.CodeGen"%>
<%@ Import namespace="Mediachase.Ibn.ObjectModel"%>
<% Mediachase.Ibn.Data.Sql.Management.Table table = (Mediachase.Ibn.Data.Sql.Management.Table)ObjectModelFactory.Create(); %>
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;

using Mediachase.IBN.Database;

namespace Mediachase.IBN.Database.EMail
{
    public class <%= table.Name%>Row
    {
    	private enum DataRowState
		{
			Unchanged,
			Added,
			Modified,
			Deleted
		}
		
        private DataRowState _state = DataRowState.Unchanged;
        
        #region Util
		static object DBNull2Null(object Value)
		{
			if(Value==DBNull.Value)
				return null;
			return Value;
		}
		#endregion
        
        <%foreach (Column column in table.Columns) {%>
        <%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)){%>
        Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> > _<%=column.Name%>;
        <%}%>
        <% else if (!TableObject.IsBinary(column.SqlDbType))
            {%>
        <%=TableObject.GetCSType(column.SqlDbType)%> _<%=column.Name%>;
        <%}%>
        <%}%>
        
        public <%= table.Name%>Row()
        {
            _state = DataRowState.Added;
            
            <%foreach (Column column in table.Columns) {%>
            <%if (!TableObject.IsBinary(column.SqlDbType))
              {%>
            <%string defValue = column.GetDefaultValue(); %>
            <%if (defValue != null){%>
            _<%=column.Name%> = <%= defValue%>;  
            <%} %>
            <%else if (column.IsNullable){%>
            _<%=column.Name%> = null;
            <%}%>
            <%} %>
            <%}%>
        }
        
		public <%= table.Name%>Row(int <%=table.PrimaryKey.Name%>)
		{
			using (IDataReader reader = DbHelper2.RunSpDataReader("mc_<%= table.Name %>Select", DbHelper2.mp("@<%=table.PrimaryKey.Name%>", SqlDbType.Int, <%=table.PrimaryKey.Name%>)))
			{
				if (reader.Read()) 
				{
					Load(reader);
				}
				else throw new Exception(String.Format("Record with {0}.{1}={2} not found", "<%= table.Name %>", "<%=table.PrimaryKey.Name%>", <%=table.PrimaryKey.Name%>));
			}
		}
		
		public <%= table.Name%>Row(IDataReader reader)
		{
		   Load(reader);
		}
		
		protected virtual void Load(IDataReader reader)
		{
			_state = DataRowState.Unchanged;
			
		<%foreach (Column column in table.Columns) {%>
		    <%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		    _<%=column.Name %> = (Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> >)DBNull2Null(reader["<%=column.Name %>"]);
		    <%} %>
		    <%else if (!TableObject.IsBinary(column.SqlDbType)){%>
			_<%=column.Name %> = (<%=TableObject.GetCSType(column.SqlDbType)%>)DBNull2Null(reader["<%=column.Name %>"]);
			<%} %>
		<%}%>
		}
	
		#region Public Properties
		
		public virtual int PrimaryKeyId
		{
            get { return _<%=table.PrimaryKey.Name%>; }		     
		}
		
        <%foreach (Column column in table.Columns) {%>
        <%if(!TableObject.IsBinary(column.SqlDbType)) {%>
      	<%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		public virtual Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> > <%= column.Name %>
	    <%}%>
	    <%else {%>
	    public virtual <%=TableObject.GetCSType(column.SqlDbType)%> <%= column.Name %>
	    <%}%>
		{
			get
			{
				return _<%= column.Name %>;
			}
			<% if (!column.Identity) {%>
			set
			{
				_<%= column.Name %> = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			<%}%>
		}
		<%}%>
		<%}%>
		#endregion
	
		public virtual void Update()
		{
			if (_state == DataRowState.Modified) 
			{
				DbHelper2.RunSp("mc_<%= table.Name %>Update"
			    <%foreach (Column column in table.Columns) {%>
			        <%if (TableObject.IsString(column.SqlDbType)) {%>
			        , DbHelper2.mp("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
			        <%} %>
			        <%else if(!TableObject.IsBinary(column.SqlDbType)){%>
			        , DbHelper2.mp("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
			        <%} %>
                <%}%> 
		        );
			}
			else if (_state == DataRowState.Added) 
			{
				SqlParameter outPutKey = new SqlParameter("@<%=table.PrimaryKey.Name%>", SqlDbType.Int);
				outPutKey.Direction = ParameterDirection.Output;

				DbHelper2.RunSp("mc_<%= table.Name %>Insert", outPutKey
		            <% foreach (Column column in table.Columns) {%>
		            <%if (column.Name!=table.PrimaryKey.Name) {%>
			        <%if (TableObject.IsString(column.SqlDbType)) {%>
			        , DbHelper2.mp("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
			        <%} %>
			        <%else if(!TableObject.IsBinary(column.SqlDbType)){%>
		            , DbHelper2.mp("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
		            <%} %>
		            <%} %>
		            <% } %> 
		        );
		        
		        _<%=table.PrimaryKey.Name%> = (int)outPutKey.Value;
			}
		}
		
		public virtual void Delete()
		{
			_state = DataRowState.Deleted;
		
			Delete(_<%=table.PrimaryKey.Name%>);
		}
		
		public static void Delete(int <%=table.PrimaryKey.Name%>)
		{
		    DbHelper2.RunSp("mc_<%= table.Name %>Delete", DbHelper2.mp("@<%=table.PrimaryKey.Name%>", SqlDbType.Int, <%=table.PrimaryKey.Name%>));
		}
    }
}
