<%@ Page language="c#" Debug="true"%>
<%@ Import namespace="Mediachase.Ibn.Data.Sql.Management"%>
<%@ Import namespace="Mediachase.CodeGen"%>
<%@ Import namespace="Mediachase.Ibn.ObjectModel"%>
<% Mediachase.Ibn.Data.Sql.Management.Table table = (Mediachase.Ibn.Data.Sql.Management.Table)ObjectModelFactory.Create(); %>
using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using Mediachase.Ibn.Data;
using Mediachase.Ibn.Data.Sql;

namespace <%= ObjectModelFactory.Params["Namespace"] %>
{
    public partial class <%= table.Name%>Row
    {
        private DataRowState _state = DataRowState.Unchanged;
        
        <%foreach (Column column in table.Columns) {%>
        <%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)){%>
        Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> > _<%=column.Name%>;
        <%}%>
        <% else if (!TableObject.IsBinary(column.SqlDbType))
            {%>
        <%=TableObject.GetCSType(column.SqlDbType)%> _<%=column.Name%>;
        <%}%>
        <%}%>
        
        public <%= table.Name%>Row()
        {
            _state = DataRowState.Added;
            
            <%foreach (Column column in table.Columns) {%>
            <%if (!TableObject.IsBinary(column.SqlDbType))
              {%>
            <%string defValue = column.GetDefaultValue(); %>
            <%if (defValue != null){%>
            _<%=column.Name%> = <%= defValue%>;  
            <%} %>
            <%else if (column.IsNullable){%>
            _<%=column.Name%> = null;
            <%}%>
            <%} %>
            <%}%>
        }
        
		public <%= table.Name%>Row(int <%=table.PrimaryKey.Name%>)
		{
			using (IDataReader reader = DataHelper.Select("<%= table.Name %>", "<%=table.PrimaryKey.Name%>", <%=table.PrimaryKey.Name%>))
			{
				if (reader.Read()) 
				{
					Load(reader);
				}
				else throw new Exception(String.Format("Record with {0}.{1}={2} not found", "<%= table.Name %>", "<%=table.PrimaryKey.Name%>", <%=table.PrimaryKey.Name%>));
			}
		}
		
		public <%= table.Name%>Row(IDataReader reader)
		{
		   Load(reader);
		}
		
		protected virtual void Load(IDataReader reader)
		{
			_state = DataRowState.Unchanged;
			
		<%foreach (Column column in table.Columns) {%>
		    <%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		    _<%=column.Name %> = (Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> >)SqlHelper.DBNull2Null(reader["<%=column.Name %>"]);
		    <%} %>
		    <%else if (!TableObject.IsBinary(column.SqlDbType)){%>
			_<%=column.Name %> = (<%=TableObject.GetCSType(column.SqlDbType)%>)SqlHelper.DBNull2Null(reader["<%=column.Name %>"]);
			<%} %>
		<%}%>
		}
	
		#region Public Properties
		
		public virtual Nullable<int> PrimaryKeyId
		{
            get { return _<%=table.PrimaryKey.Name%>; }		     
		}
		
        <%foreach (Column column in table.Columns) {%>
        <%if(!TableObject.IsBinary(column.SqlDbType)) {%>
      	<%if (column.IsNullable && TableObject.IsPrimitive(column.SqlDbType)) {%>
		public virtual Nullable< <%=TableObject.GetCSType(column.SqlDbType)%> > <%= column.Name %>
	    <%}%>
	    <%else {%>
	    public virtual <%=TableObject.GetCSType(column.SqlDbType)%> <%= column.Name %>
	    <%}%>
		{
			get
			{
				return _<%= column.Name %>;
			}
			<% if (!column.Identity) {%>
			set
			{
				_<%= column.Name %> = value;
				if (_state == DataRowState.Unchanged)
				{
					_state = DataRowState.Modified;
				}
			}	
			<%}%>
		}
		<%}%>
		<%}%>
		#endregion
	
	    public static <%= table.Name %>Row[] List()
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>"))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new <%= table.Name %>Row(reader));
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }
	
	    public static <%= table.Name %>Row[] List(params SortingElement[] sorting)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", sorting))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new <%= table.Name %>Row(reader));
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }
	
	    public static <%= table.Name %>Row[] List(params FilterElement[] filters)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new <%= table.Name %>Row(reader));
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }
	
	    public static <%= table.Name %>Row[] List(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters, sorting))
	       {
	          while (reader.Read()) 
	          {
			      list.Add(new <%= table.Name %>Row(reader));
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }

	    public static <%= table.Name %>Row[] List(FilterElementCollection filters, SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", filters, sorting))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new <%= table.Name %>Row(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }
	
	    public static <%= table.Name %>Row[] List(SortingElementCollection sorting, int start, int count)
	    {
	       ArrayList list = new ArrayList(); 
	    
	       using (IDataReader reader = DataHelper.List("<%= table.Name %>", sorting.ToArray()))
	       {
	          while (reader.Read() && count > 0) 
	          {
	              if (start == 0)
	              {  
			          list.Add(new <%= table.Name %>Row(reader));
			          
			          count--;
			      }
			      else start--;
			  } 
	       }
	       return (<%= table.Name %>Row[])list.ToArray(typeof(<%= table.Name %>Row));
	    }
	
	    public static int GetTotalCount(params FilterElement[] filters)
	    {
	        return DataHelper.GetTotalCount("<%= table.Name %>", filters);
	    }
	
	    public static IDataReader GetReader()
	    {
	       return DataHelper.List("<%= table.Name %>");
	    }
	
	    public static IDataReader GetReader(params FilterElement[] filters)
	    {
	       return DataHelper.List("<%= table.Name %>", filters);
	    }
	
	    public static IDataReader GetReader(FilterElementCollection filters, SortingElementCollection sorting)
	    {
	       return DataHelper.List("<%= table.Name %>", filters, sorting);
	    }
	
	    public static DataTable GetTable()
	    {
	       return DataHelper.GetDataTable("<%= table.Name %>");
	    }
	
	    public static DataTable GetTable(params FilterElement[] filters)
	    {
	       return DataHelper.GetDataTable("<%= table.Name %>", filters);
	    }
	
		public virtual void Update()
		{
			if (_state == DataRowState.Modified) 
			{
				DataHelper.Update("<%= table.Name %>"
			    <%foreach (Column column in table.Columns) {%>
			        <%if (TableObject.IsString(column.SqlDbType)) {%>
			        , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
			        <%} %>
			        <%else if(!TableObject.IsBinary(column.SqlDbType)){%>
			        , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
			        <%} %>
                <%}%> 
		        );
			}
			else if (_state == DataRowState.Added) 
			{
			    <% if (table.Columns[table.PrimaryKey.Name].Identity) {%>
				_<%=table.PrimaryKey.Name%> = DataHelper.Insert("<%= table.Name %>", "<%=table.PrimaryKey.Name%>" 
		            <% foreach (Column column in table.Columns) {%>
			        <%if (TableObject.IsString(column.SqlDbType)) {%>
			        , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
			        <%} %>
			        <%else if(!TableObject.IsBinary(column.SqlDbType)){%>
		            , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
		            <%} %>
		            <% } %> 
		        );
		        <% } %>
	            <% else {%>
				DataHelper.Insert("<%= table.Name %>"
		            <%foreach (Column column in table.Columns) {%>
			        <%if (TableObject.IsString(column.SqlDbType)) {%>
			        , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, <%=column.Precision%>, _<%=column.Name%>)
			        <%} %>
			        <%else if (!TableObject.IsBinary(column.SqlDbType)){%>
		            , SqlHelper.SqlParameter("@<%=column.Name%>", SqlDbType.<%=TableObject.GetSqlType(column.SqlDbType)%>, _<%=column.Name%>)
		            <%} %>
		            <%} %>
				);	
	            <%} %>
			}
		}
		
		public virtual void Delete()
		{
			_state = DataRowState.Deleted;
		
			Delete(_<%=table.PrimaryKey.Name%>);
		}
		
		public static void Delete(int <%=table.PrimaryKey.Name%>)
		{
			DataHelper.Delete("<%= table.Name %>", "<%=table.PrimaryKey.Name%>", <%=table.PrimaryKey.Name%>);
		}
    }
}
